import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ball here.
 * 
 * Brad Matias 
 * 9-7-12
 */
public class Ball extends Shared
{
    private int oneShot = 0;
    /**
     * Act - do whatever the ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move();
        turn();
        death();
        WIN();
        shooter();

    }  

    public void shooter(){

        if(Greenfoot.isKeyDown("space")){
            if(oneShot==0){
                Greenfoot.playSound("shoot.wav");
                Bullet bullet = new Bullet();
                bullet.setRotation(getRotation());
                getWorld().addObject(bullet,getX(),getY());
                oneShot=1;
            }

        }
        else{
            oneShot=0;
        }
    }

    /**
     * this is a random number generator that passes an integer to rand()
     */
    public int rand(){
        return Greenfoot.getRandomNumber(3);
    }

    /**
     * this method uses the intersection info from hit() to reset the ball and play a sound
     */
    public void death(){
        if(hit(vside.class)){
            setLocation(50,550);
            if(rand()== 1){
                Greenfoot.playSound("lose.wav");
            }
            if(rand()== 2){
                Greenfoot.playSound("lose3.wav");
            }
            else{
                Greenfoot.playSound("lose2.wav");
            }
        }
        else if(hit(side.class)){
            setLocation(50,550);
            if(rand()== 1){
                Greenfoot.playSound("lose.wav");
            }
            if(rand()== 2){
                Greenfoot.playSound("lose3.wav");
            }
            else{
                Greenfoot.playSound("lose2.wav");
            }
        }
        else if(hit(longside.class)){
            setLocation(50,550);
            if(rand()== 1){
                Greenfoot.playSound("lose.wav");
            }
            if(rand()== 2){
                Greenfoot.playSound("lose3.wav");
            }
            else{
                Greenfoot.playSound("lose2.wav");
            }
        }
        else if(hit(badguy.class)){
            setLocation(50,550);
            if(rand()== 1){
                Greenfoot.playSound("lose.wav");
            }
            if(rand()== 2){
                Greenfoot.playSound("lose3.wav");
            }
            else{
                Greenfoot.playSound("lose2.wav");
            }
        }
        else if(atWorldEdge()){
            setLocation(50,550);
            if(rand()== 1){
                Greenfoot.playSound("lose.wav");
            }
            if(rand()== 2){
                Greenfoot.playSound("lose3.wav");
            }
            else{
                Greenfoot.playSound("lose2.wav");
            }
        }
    }

    /**
     * this method uses the intersection info from hit() to reset the ball and play a sound
     */
    public void WIN(){
        if(easyHit(goal.class)){
            setLocation(50,550);
            Greenfoot.playSound("win.wav");
        }
    }

    /**
     * this method will move the ball forward when the spacebar is pressed
     */
    public void move(){
        if(Greenfoot.isKeyDown("up")){
            move(3);

        }
    }

    /**
     * this method will turn the ball left and right using the arrow keys
     */
    public void turn(){
        if(Greenfoot.isKeyDown("left")){
            turn(-5);
        }
        if(Greenfoot.isKeyDown("right")){
            turn(5);
        }
    }


}
